#include "Keyboard.h"

const int ativaEntrada = 4;
const int pinoLed = 8;

bool entradaAtiva = false; 
int ultimoEstadoAtivaEntrada = HIGH;

unsigned long controleTaxaRepeticaoTeclado = 0;
const int taxaRepeticaoTeclado = 3000;

void setup() 
{
  Keyboard.begin();
  
  pinMode(ativaEntrada, INPUT_PULLUP);
  pinMode(pinoLed, OUTPUT);
}

void loop() 
{
  int estadoLigaEntrada = digitalRead(ativaEntrada);
  
  //Verifica se o botão de ativação para controle do teclado foi pressionado
  if(estadoLigaEntrada != ultimoEstadoAtivaEntrada) 
  {
    if (estadoLigaEntrada == LOW) 
    {
      entradaAtiva = !entradaAtiva;
      digitalWrite(pinoLed, entradaAtiva);
    }
  }
  
  ultimoEstadoAtivaEntrada = estadoLigaEntrada;
  
  //Somente controla o teclado se o botão de ativação for pressionado
  if(entradaAtiva)
  {
    if((millis() - controleTaxaRepeticaoTeclado) > taxaRepeticaoTeclado)
    {
      Keyboard.press('B');
      Keyboard.release('B');
      
      //Keyboard.releaseAll();
      
      //Keyboard.write('B'); //Não necessita usar release ou releaseAll
      
      controleTaxaRepeticaoTeclado = millis();
    }
  }
  
  delay(100);
}
